// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: commonmodule/commonmodule.proto

package openfmb.commonmodule;

/**
 * <pre>
 * This is a root class to provide common identification for all classes needing identification and
 * naming attributes.
 * </pre>
 *
 * Protobuf type {@code commonmodule.IdentifiedObject}
 */
public final class IdentifiedObject extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:commonmodule.IdentifiedObject)
    IdentifiedObjectOrBuilder {
private static final long serialVersionUID = 0L;
  // Use IdentifiedObject.newBuilder() to construct.
  private IdentifiedObject(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private IdentifiedObject() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new IdentifiedObject();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_IdentifiedObject_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_IdentifiedObject_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.commonmodule.IdentifiedObject.class, openfmb.commonmodule.IdentifiedObject.Builder.class);
  }

  public static final int DESCRIPTION_FIELD_NUMBER = 1;
  private com.google.protobuf.StringValue description_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.google.protobuf.StringValue description = 1;</code>
   * @return Whether the description field is set.
   */
  @java.lang.Override
  public boolean hasDescription() {
    return description_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.google.protobuf.StringValue description = 1;</code>
   * @return The description.
   */
  @java.lang.Override
  public com.google.protobuf.StringValue getDescription() {
    return description_ == null ? com.google.protobuf.StringValue.getDefaultInstance() : description_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.google.protobuf.StringValue description = 1;</code>
   */
  @java.lang.Override
  public com.google.protobuf.StringValueOrBuilder getDescriptionOrBuilder() {
    return description_ == null ? com.google.protobuf.StringValue.getDefaultInstance() : description_;
  }

  public static final int MRID_FIELD_NUMBER = 2;
  private com.google.protobuf.StringValue mRID_;
  /**
   * <pre>
   * Master resource identifier issued by a model authority. The mRID must semantically be a UUID as
   * specified in RFC 4122. The mRID is globally unique.
   * </pre>
   *
   * <code>.google.protobuf.StringValue mRID = 2 [(.uml.option_uuid) = true];</code>
   * @return Whether the mRID field is set.
   */
  @java.lang.Override
  public boolean hasMRID() {
    return mRID_ != null;
  }
  /**
   * <pre>
   * Master resource identifier issued by a model authority. The mRID must semantically be a UUID as
   * specified in RFC 4122. The mRID is globally unique.
   * </pre>
   *
   * <code>.google.protobuf.StringValue mRID = 2 [(.uml.option_uuid) = true];</code>
   * @return The mRID.
   */
  @java.lang.Override
  public com.google.protobuf.StringValue getMRID() {
    return mRID_ == null ? com.google.protobuf.StringValue.getDefaultInstance() : mRID_;
  }
  /**
   * <pre>
   * Master resource identifier issued by a model authority. The mRID must semantically be a UUID as
   * specified in RFC 4122. The mRID is globally unique.
   * </pre>
   *
   * <code>.google.protobuf.StringValue mRID = 2 [(.uml.option_uuid) = true];</code>
   */
  @java.lang.Override
  public com.google.protobuf.StringValueOrBuilder getMRIDOrBuilder() {
    return mRID_ == null ? com.google.protobuf.StringValue.getDefaultInstance() : mRID_;
  }

  public static final int NAME_FIELD_NUMBER = 3;
  private com.google.protobuf.StringValue name_;
  /**
   * <pre>
   * The name is any free human readable and possibly non unique text naming the object.
   * </pre>
   *
   * <code>.google.protobuf.StringValue name = 3;</code>
   * @return Whether the name field is set.
   */
  @java.lang.Override
  public boolean hasName() {
    return name_ != null;
  }
  /**
   * <pre>
   * The name is any free human readable and possibly non unique text naming the object.
   * </pre>
   *
   * <code>.google.protobuf.StringValue name = 3;</code>
   * @return The name.
   */
  @java.lang.Override
  public com.google.protobuf.StringValue getName() {
    return name_ == null ? com.google.protobuf.StringValue.getDefaultInstance() : name_;
  }
  /**
   * <pre>
   * The name is any free human readable and possibly non unique text naming the object.
   * </pre>
   *
   * <code>.google.protobuf.StringValue name = 3;</code>
   */
  @java.lang.Override
  public com.google.protobuf.StringValueOrBuilder getNameOrBuilder() {
    return name_ == null ? com.google.protobuf.StringValue.getDefaultInstance() : name_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (description_ != null) {
      output.writeMessage(1, getDescription());
    }
    if (mRID_ != null) {
      output.writeMessage(2, getMRID());
    }
    if (name_ != null) {
      output.writeMessage(3, getName());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (description_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getDescription());
    }
    if (mRID_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getMRID());
    }
    if (name_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, getName());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.commonmodule.IdentifiedObject)) {
      return super.equals(obj);
    }
    openfmb.commonmodule.IdentifiedObject other = (openfmb.commonmodule.IdentifiedObject) obj;

    if (hasDescription() != other.hasDescription()) return false;
    if (hasDescription()) {
      if (!getDescription()
          .equals(other.getDescription())) return false;
    }
    if (hasMRID() != other.hasMRID()) return false;
    if (hasMRID()) {
      if (!getMRID()
          .equals(other.getMRID())) return false;
    }
    if (hasName() != other.hasName()) return false;
    if (hasName()) {
      if (!getName()
          .equals(other.getName())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasDescription()) {
      hash = (37 * hash) + DESCRIPTION_FIELD_NUMBER;
      hash = (53 * hash) + getDescription().hashCode();
    }
    if (hasMRID()) {
      hash = (37 * hash) + MRID_FIELD_NUMBER;
      hash = (53 * hash) + getMRID().hashCode();
    }
    if (hasName()) {
      hash = (37 * hash) + NAME_FIELD_NUMBER;
      hash = (53 * hash) + getName().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.commonmodule.IdentifiedObject parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.IdentifiedObject parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.IdentifiedObject parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.IdentifiedObject parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.IdentifiedObject parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.IdentifiedObject parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.IdentifiedObject parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.IdentifiedObject parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.commonmodule.IdentifiedObject parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.IdentifiedObject parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.commonmodule.IdentifiedObject parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.IdentifiedObject parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.commonmodule.IdentifiedObject prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * This is a root class to provide common identification for all classes needing identification and
   * naming attributes.
   * </pre>
   *
   * Protobuf type {@code commonmodule.IdentifiedObject}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:commonmodule.IdentifiedObject)
      openfmb.commonmodule.IdentifiedObjectOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_IdentifiedObject_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_IdentifiedObject_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.commonmodule.IdentifiedObject.class, openfmb.commonmodule.IdentifiedObject.Builder.class);
    }

    // Construct using openfmb.commonmodule.IdentifiedObject.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      description_ = null;
      if (descriptionBuilder_ != null) {
        descriptionBuilder_.dispose();
        descriptionBuilder_ = null;
      }
      mRID_ = null;
      if (mRIDBuilder_ != null) {
        mRIDBuilder_.dispose();
        mRIDBuilder_ = null;
      }
      name_ = null;
      if (nameBuilder_ != null) {
        nameBuilder_.dispose();
        nameBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_IdentifiedObject_descriptor;
    }

    @java.lang.Override
    public openfmb.commonmodule.IdentifiedObject getDefaultInstanceForType() {
      return openfmb.commonmodule.IdentifiedObject.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.commonmodule.IdentifiedObject build() {
      openfmb.commonmodule.IdentifiedObject result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.commonmodule.IdentifiedObject buildPartial() {
      openfmb.commonmodule.IdentifiedObject result = new openfmb.commonmodule.IdentifiedObject(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.commonmodule.IdentifiedObject result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.description_ = descriptionBuilder_ == null
            ? description_
            : descriptionBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.mRID_ = mRIDBuilder_ == null
            ? mRID_
            : mRIDBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000004) != 0)) {
        result.name_ = nameBuilder_ == null
            ? name_
            : nameBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.commonmodule.IdentifiedObject) {
        return mergeFrom((openfmb.commonmodule.IdentifiedObject)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.commonmodule.IdentifiedObject other) {
      if (other == openfmb.commonmodule.IdentifiedObject.getDefaultInstance()) return this;
      if (other.hasDescription()) {
        mergeDescription(other.getDescription());
      }
      if (other.hasMRID()) {
        mergeMRID(other.getMRID());
      }
      if (other.hasName()) {
        mergeName(other.getName());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getDescriptionFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 18: {
              input.readMessage(
                  getMRIDFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            case 26: {
              input.readMessage(
                  getNameFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000004;
              break;
            } // case 26
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private com.google.protobuf.StringValue description_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.StringValue, com.google.protobuf.StringValue.Builder, com.google.protobuf.StringValueOrBuilder> descriptionBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.StringValue description = 1;</code>
     * @return Whether the description field is set.
     */
    public boolean hasDescription() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.StringValue description = 1;</code>
     * @return The description.
     */
    public com.google.protobuf.StringValue getDescription() {
      if (descriptionBuilder_ == null) {
        return description_ == null ? com.google.protobuf.StringValue.getDefaultInstance() : description_;
      } else {
        return descriptionBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.StringValue description = 1;</code>
     */
    public Builder setDescription(com.google.protobuf.StringValue value) {
      if (descriptionBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        description_ = value;
      } else {
        descriptionBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.StringValue description = 1;</code>
     */
    public Builder setDescription(
        com.google.protobuf.StringValue.Builder builderForValue) {
      if (descriptionBuilder_ == null) {
        description_ = builderForValue.build();
      } else {
        descriptionBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.StringValue description = 1;</code>
     */
    public Builder mergeDescription(com.google.protobuf.StringValue value) {
      if (descriptionBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          description_ != null &&
          description_ != com.google.protobuf.StringValue.getDefaultInstance()) {
          getDescriptionBuilder().mergeFrom(value);
        } else {
          description_ = value;
        }
      } else {
        descriptionBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.StringValue description = 1;</code>
     */
    public Builder clearDescription() {
      bitField0_ = (bitField0_ & ~0x00000001);
      description_ = null;
      if (descriptionBuilder_ != null) {
        descriptionBuilder_.dispose();
        descriptionBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.StringValue description = 1;</code>
     */
    public com.google.protobuf.StringValue.Builder getDescriptionBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getDescriptionFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.StringValue description = 1;</code>
     */
    public com.google.protobuf.StringValueOrBuilder getDescriptionOrBuilder() {
      if (descriptionBuilder_ != null) {
        return descriptionBuilder_.getMessageOrBuilder();
      } else {
        return description_ == null ?
            com.google.protobuf.StringValue.getDefaultInstance() : description_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.StringValue description = 1;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.StringValue, com.google.protobuf.StringValue.Builder, com.google.protobuf.StringValueOrBuilder> 
        getDescriptionFieldBuilder() {
      if (descriptionBuilder_ == null) {
        descriptionBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.StringValue, com.google.protobuf.StringValue.Builder, com.google.protobuf.StringValueOrBuilder>(
                getDescription(),
                getParentForChildren(),
                isClean());
        description_ = null;
      }
      return descriptionBuilder_;
    }

    private com.google.protobuf.StringValue mRID_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.StringValue, com.google.protobuf.StringValue.Builder, com.google.protobuf.StringValueOrBuilder> mRIDBuilder_;
    /**
     * <pre>
     * Master resource identifier issued by a model authority. The mRID must semantically be a UUID as
     * specified in RFC 4122. The mRID is globally unique.
     * </pre>
     *
     * <code>.google.protobuf.StringValue mRID = 2 [(.uml.option_uuid) = true];</code>
     * @return Whether the mRID field is set.
     */
    public boolean hasMRID() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * Master resource identifier issued by a model authority. The mRID must semantically be a UUID as
     * specified in RFC 4122. The mRID is globally unique.
     * </pre>
     *
     * <code>.google.protobuf.StringValue mRID = 2 [(.uml.option_uuid) = true];</code>
     * @return The mRID.
     */
    public com.google.protobuf.StringValue getMRID() {
      if (mRIDBuilder_ == null) {
        return mRID_ == null ? com.google.protobuf.StringValue.getDefaultInstance() : mRID_;
      } else {
        return mRIDBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Master resource identifier issued by a model authority. The mRID must semantically be a UUID as
     * specified in RFC 4122. The mRID is globally unique.
     * </pre>
     *
     * <code>.google.protobuf.StringValue mRID = 2 [(.uml.option_uuid) = true];</code>
     */
    public Builder setMRID(com.google.protobuf.StringValue value) {
      if (mRIDBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        mRID_ = value;
      } else {
        mRIDBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Master resource identifier issued by a model authority. The mRID must semantically be a UUID as
     * specified in RFC 4122. The mRID is globally unique.
     * </pre>
     *
     * <code>.google.protobuf.StringValue mRID = 2 [(.uml.option_uuid) = true];</code>
     */
    public Builder setMRID(
        com.google.protobuf.StringValue.Builder builderForValue) {
      if (mRIDBuilder_ == null) {
        mRID_ = builderForValue.build();
      } else {
        mRIDBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Master resource identifier issued by a model authority. The mRID must semantically be a UUID as
     * specified in RFC 4122. The mRID is globally unique.
     * </pre>
     *
     * <code>.google.protobuf.StringValue mRID = 2 [(.uml.option_uuid) = true];</code>
     */
    public Builder mergeMRID(com.google.protobuf.StringValue value) {
      if (mRIDBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          mRID_ != null &&
          mRID_ != com.google.protobuf.StringValue.getDefaultInstance()) {
          getMRIDBuilder().mergeFrom(value);
        } else {
          mRID_ = value;
        }
      } else {
        mRIDBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Master resource identifier issued by a model authority. The mRID must semantically be a UUID as
     * specified in RFC 4122. The mRID is globally unique.
     * </pre>
     *
     * <code>.google.protobuf.StringValue mRID = 2 [(.uml.option_uuid) = true];</code>
     */
    public Builder clearMRID() {
      bitField0_ = (bitField0_ & ~0x00000002);
      mRID_ = null;
      if (mRIDBuilder_ != null) {
        mRIDBuilder_.dispose();
        mRIDBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Master resource identifier issued by a model authority. The mRID must semantically be a UUID as
     * specified in RFC 4122. The mRID is globally unique.
     * </pre>
     *
     * <code>.google.protobuf.StringValue mRID = 2 [(.uml.option_uuid) = true];</code>
     */
    public com.google.protobuf.StringValue.Builder getMRIDBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getMRIDFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Master resource identifier issued by a model authority. The mRID must semantically be a UUID as
     * specified in RFC 4122. The mRID is globally unique.
     * </pre>
     *
     * <code>.google.protobuf.StringValue mRID = 2 [(.uml.option_uuid) = true];</code>
     */
    public com.google.protobuf.StringValueOrBuilder getMRIDOrBuilder() {
      if (mRIDBuilder_ != null) {
        return mRIDBuilder_.getMessageOrBuilder();
      } else {
        return mRID_ == null ?
            com.google.protobuf.StringValue.getDefaultInstance() : mRID_;
      }
    }
    /**
     * <pre>
     * Master resource identifier issued by a model authority. The mRID must semantically be a UUID as
     * specified in RFC 4122. The mRID is globally unique.
     * </pre>
     *
     * <code>.google.protobuf.StringValue mRID = 2 [(.uml.option_uuid) = true];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.StringValue, com.google.protobuf.StringValue.Builder, com.google.protobuf.StringValueOrBuilder> 
        getMRIDFieldBuilder() {
      if (mRIDBuilder_ == null) {
        mRIDBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.StringValue, com.google.protobuf.StringValue.Builder, com.google.protobuf.StringValueOrBuilder>(
                getMRID(),
                getParentForChildren(),
                isClean());
        mRID_ = null;
      }
      return mRIDBuilder_;
    }

    private com.google.protobuf.StringValue name_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.StringValue, com.google.protobuf.StringValue.Builder, com.google.protobuf.StringValueOrBuilder> nameBuilder_;
    /**
     * <pre>
     * The name is any free human readable and possibly non unique text naming the object.
     * </pre>
     *
     * <code>.google.protobuf.StringValue name = 3;</code>
     * @return Whether the name field is set.
     */
    public boolean hasName() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <pre>
     * The name is any free human readable and possibly non unique text naming the object.
     * </pre>
     *
     * <code>.google.protobuf.StringValue name = 3;</code>
     * @return The name.
     */
    public com.google.protobuf.StringValue getName() {
      if (nameBuilder_ == null) {
        return name_ == null ? com.google.protobuf.StringValue.getDefaultInstance() : name_;
      } else {
        return nameBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * The name is any free human readable and possibly non unique text naming the object.
     * </pre>
     *
     * <code>.google.protobuf.StringValue name = 3;</code>
     */
    public Builder setName(com.google.protobuf.StringValue value) {
      if (nameBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        name_ = value;
      } else {
        nameBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * The name is any free human readable and possibly non unique text naming the object.
     * </pre>
     *
     * <code>.google.protobuf.StringValue name = 3;</code>
     */
    public Builder setName(
        com.google.protobuf.StringValue.Builder builderForValue) {
      if (nameBuilder_ == null) {
        name_ = builderForValue.build();
      } else {
        nameBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * The name is any free human readable and possibly non unique text naming the object.
     * </pre>
     *
     * <code>.google.protobuf.StringValue name = 3;</code>
     */
    public Builder mergeName(com.google.protobuf.StringValue value) {
      if (nameBuilder_ == null) {
        if (((bitField0_ & 0x00000004) != 0) &&
          name_ != null &&
          name_ != com.google.protobuf.StringValue.getDefaultInstance()) {
          getNameBuilder().mergeFrom(value);
        } else {
          name_ = value;
        }
      } else {
        nameBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * The name is any free human readable and possibly non unique text naming the object.
     * </pre>
     *
     * <code>.google.protobuf.StringValue name = 3;</code>
     */
    public Builder clearName() {
      bitField0_ = (bitField0_ & ~0x00000004);
      name_ = null;
      if (nameBuilder_ != null) {
        nameBuilder_.dispose();
        nameBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * The name is any free human readable and possibly non unique text naming the object.
     * </pre>
     *
     * <code>.google.protobuf.StringValue name = 3;</code>
     */
    public com.google.protobuf.StringValue.Builder getNameBuilder() {
      bitField0_ |= 0x00000004;
      onChanged();
      return getNameFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * The name is any free human readable and possibly non unique text naming the object.
     * </pre>
     *
     * <code>.google.protobuf.StringValue name = 3;</code>
     */
    public com.google.protobuf.StringValueOrBuilder getNameOrBuilder() {
      if (nameBuilder_ != null) {
        return nameBuilder_.getMessageOrBuilder();
      } else {
        return name_ == null ?
            com.google.protobuf.StringValue.getDefaultInstance() : name_;
      }
    }
    /**
     * <pre>
     * The name is any free human readable and possibly non unique text naming the object.
     * </pre>
     *
     * <code>.google.protobuf.StringValue name = 3;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.StringValue, com.google.protobuf.StringValue.Builder, com.google.protobuf.StringValueOrBuilder> 
        getNameFieldBuilder() {
      if (nameBuilder_ == null) {
        nameBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.StringValue, com.google.protobuf.StringValue.Builder, com.google.protobuf.StringValueOrBuilder>(
                getName(),
                getParentForChildren(),
                isClean());
        name_ = null;
      }
      return nameBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:commonmodule.IdentifiedObject)
  }

  // @@protoc_insertion_point(class_scope:commonmodule.IdentifiedObject)
  private static final openfmb.commonmodule.IdentifiedObject DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.commonmodule.IdentifiedObject();
  }

  public static openfmb.commonmodule.IdentifiedObject getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<IdentifiedObject>
      PARSER = new com.google.protobuf.AbstractParser<IdentifiedObject>() {
    @java.lang.Override
    public IdentifiedObject parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<IdentifiedObject> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<IdentifiedObject> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.commonmodule.IdentifiedObject getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

